from abc import abstractmethod
from typing import Callable

from cpl_core.application import StartupExtensionABC
from cpl_discord.service.discord_collection_abc import DiscordCollectionABC


class ModuleABC(StartupExtensionABC):

    @abstractmethod
    def __init__(self, dc: DiscordCollectionABC, feature_flag: Callable = None):
        StartupExtensionABC.__init__(self)

        self._dc = dc
        self._feature_flag = feature_flag

    @property
    def feature_flag(self) -> Callable:
        return self._feature_flag
